LinuxShell

监控 MySQL 主从同步状态是否异常脚本

  1. #!/bin/bash
  2. HOST=localhost
  3. USER=root
  4. PASSWD=123.com
  5. IO_SQL_STATUS=$(mysql -h$HOST -u$USER -p$PASSWD -e 'show slave status\G' 2>/dev/null |awk '/Slave_.*_Running:/{print $1$2}')
  6. for i in $IO_SQL_STATUS; do
  7. THREAD_STATUS_NAME=${i%:*}
  8. THREAD_STATUS=${i#*:}
  9. if [ "$THREAD_STATUS" != "Yes" ]; then
  10. echo "Error: MySQL Master-Slave $THREAD_STATUS_NAME status is $THREAD_STATUS!" |mail -s "Master-Slave Staus" [url=mailto:xxx@163.com]xxx@163.com[/url]
  11. fi
  12. done

目录文件变化监控和实时文件同步

  1. #!/bin/bash
  2. MON_DIR=/opt
  3. inotifywait -mqr --format %f -e create $MON_DIR |\
  4. while read files; do
  5. rsync -avz /opt /tmp/opt
  6. #echo "$(date +'%F %T') create $files" | mail -s "dir monitor" [url=mailto:xxx@163.com]xxx@163.com[/url]
  7. done

批量创建 100 用户并设置密码脚本

  1. #!/bin/bash
  2. DATE=$@
  3. USER_FILE=user.txt
  4. for USER in $USER_LIST; do
  5. if ! id $USER &>/dev/null; then
  6. PASS=$(echo $RANDOM |md5sum |cut -c 1-8)
  7. useradd $USER
  8. echo $PASS |passwd --stdin $USER &>/dev/null
  9. echo "$USER $PASS" >> $USER_FILE
  10. echo "$USER User create successful."
  11. else
  12. echo "$USER User already exists!"
  13. fi
  14. done

批量检测网站是否异常脚本

  1. #!/bin/bash
  2. URL_LIST="www.baidu.com [url=http://www.ctnrs.com]www.ctnrs.com[/url]"
  3. for URL in $URL_LIST; do
  4. FAIL_COUNT=0
  5. for ((i=1;i<=3;i++)); do
  6. HTTP_CODE=$(curl -o /dev/null --connect-timeout 3 -s -w "%{http_code}" $URL)
  7. if [ $HTTP_CODE -eq 200 ]; then
  8. echo "$URL OK"
  9. break
  10. else
  11. echo "$URL retry $FAIL_COUNT"
  12. let FAIL_COUNT++
  13. fi
  14. done
  15. if [ $FAIL_COUNT -eq 3 ]; then
  16. echo "Warning: $URL Access failure!"
  17. fi
  18. done

批量主机远程执行命令脚本

  1. #!/bin/bash
  2. COMMAND=$*
  3. HOST_INFO=host.info
  4. for IP in $(awk '/^[^#]/{print $1}' $HOST_INFO); do
  5. USER=$(awk -v ip=$IP 'ip==$1{print $2}' $HOST_INFO)
  6. PORT=$(awk -v ip=$IP 'ip==$1{print $3}' $HOST_INFO)
  7. PASS=$(awk -v ip=$IP 'ip==$1{print $4}' $HOST_INFO)
  8. expect -c "
  9. spawn ssh -p $PORT $USER@$IP
  10. expect {
  11. \"(yes/no)\" {send \"yes\r\"; exp_continue}
  12. \"password:\" {send \"$PASS\r\"; exp_continue}
  13. \"$USER@*\" {send \"$COMMAND\r exit\r\"; exp_continue}
  14. }
  15. "
  16. echo "-------------------"
  17. done

一键部署 LNMP 网站平台脚本

  1. #!/bin/bash
  2. NGINX_V=1.15.6
  3. PHP_V=5.6.36
  4. TMP_DIR=/tmp
  5. INSTALL_DIR=/usr/local
  6. PWD_C=$PWD
  7. echo
  8. echo -e "\tMenu\n"
  9. echo -e "1. Install Nginx"
  10. echo -e "2. Install PHP"
  11. echo -e "3. Install MySQL"
  12. echo -e "4. Deploy LNMP"
  13. echo -e "9. Quit"
  14. function command_status_check() {
  15. if [ $? -ne 0 ]; then
  16. echo $1
  17. exit
  18. fi
  19. }
  20. function install_nginx() {
  21. cd $TMP_DIR
  22. yum install -y gcc gcc-c++ make openssl-devel pcre-devel wget
  23. wget [url=http://nginx.org/download/nginx-]http://nginx.org/download/nginx-[/url]${NGINX_V}.tar.gz
  24. tar zxf nginx-${NGINX_V}.tar.gz
  25. cd nginx-${NGINX_V}
  26. ./configure --prefix=$INSTALL_DIR/nginx \
  27. --with-http_ssl_module \
  28. --with-http_stub_status_module \
  29. --with-stream
  30. command_status_check "Nginx - 平台环境检查失败!"
  31. make -j 4
  32. command_status_check "Nginx - 编译失败!"
  33. make install
  34. command_status_check "Nginx - 安装失败!"
  35. mkdir -p $INSTALL_DIR/nginx/conf/vhost
  36. alias cp=cp ; cp -rf $PWD_C/nginx.conf $INSTALL_DIR/nginx/conf
  37. rm -rf $INSTALL_DIR/nginx/html/*
  38. echo "ok" > $INSTALL_DIR/nginx/html/status.html
  39. echo '<?php echo "ok"?>' > $INSTALL_DIR/nginx/html/status.php
  40. $INSTALL_DIR/nginx/sbin/nginx
  41. command_status_check "Nginx - 启动失败!"
  42. }
  43. function install_php() {
  44. cd $TMP_DIR
  45. yum install -y gcc gcc-c++ make gd-devel libxml2-devel \
  46. libcurl-devel libjpeg-devel libpng-devel openssl-devel \
  47. libmcrypt-devel libxslt-devel libtidy-devel
  48. wget [url=http://docs.php.net/distributions/php-]http://docs.php.net/distributions/php-[/url]${PHP_V}.tar.gz
  49. tar zxf php-${PHP_V}.tar.gz
  50. cd php-${PHP_V}
  51. ./configure --prefix=$INSTALL_DIR/php \
  52. --with-config-file-path=$INSTALL_DIR/php/etc \
  53. --enable-fpm --enable-opcache \
  54. --with-mysql --with-mysqli --with-pdo-mysql \
  55. --with-openssl --with-zlib --with-curl --with-gd \
  56. --with-jpeg-dir --with-png-dir --with-freetype-dir \
  57. --enable-mbstring --enable-hash
  58. command_status_check "PHP - 平台环境检查失败!"
  59. make -j 4
  60. command_status_check "PHP - 编译失败!"
  61. make install
  62. command_status_check "PHP - 安装失败!"
  63. cp php.ini-production $INSTALL_DIR/php/etc/php.ini
  64. cp sapi/fpm/php-fpm.conf $INSTALL_DIR/php/etc/php-fpm.conf
  65. cp sapi/fpm/init.d.php-fpm /etc/init.d/php-fpm
  66. chmod +x /etc/init.d/php-fpm
  67. /etc/init.d/php-fpm start
  68. command_status_check "PHP - 启动失败!"
  69. }
  70. read -p "请输入编号:" number
  71. case $number in
  72. 1)
  73. install_nginx;;
  74. 2)
  75. install_php;;
  76. 3)
  77. install_mysql;;
  78. 4)
  79. install_nginx
  80. install_php
  81. ;;
  82. 9)
  83. exit;;
  84. esac

一键查看服务器资源利用率

  1. #!/bin/bash
  2. function cpu() {
  3. NUM=1
  4. while [ $NUM -le 3 ]; do
  5. util=`vmstat |awk '{if(NR==3)print 100-$15"%"}'`
  6. user=`vmstat |awk '{if(NR==3)print $13"%"}'`
  7. sys=`vmstat |awk '{if(NR==3)print $14"%"}'`
  8. iowait=`vmstat |awk '{if(NR==3)print $16"%"}'`
  9. echo "CPU - 使用率: $util , 等待磁盘IO响应使用率: $iowait"
  10. let NUM++
  11. sleep 1
  12. done
  13. }
  14. function memory() {
  15. total=`free -m |awk '{if(NR==2)printf "%.1f",$2/1024}'`
  16. used=`free -m |awk '{if(NR==2) printf "%.1f",($2-$NF)/1024}'`
  17. available=`free -m |awk '{if(NR==2) printf "%.1f",$NF/1024}'`
  18. echo "内存 - 总大小: ${total}G , 使用: ${used}G , 剩余: ${available}G"
  19. }
  20. function disk() {
  21. fs=$(df -h |awk '/^\/dev/{print $1}')
  22. for p in $fs; do
  23. mounted=$(df -h |awk '$1=="'$p'"{print $NF}')
  24. size=$(df -h |awk '$1=="'$p'"{print $2}')
  25. used=$(df -h |awk '$1=="'$p'"{print $3}')
  26. used_percent=$(df -h |awk '$1=="'$p'"{print $5}')
  27. echo "硬盘 - 挂载点: $mounted , 总大小: $size , 使用: $used , 使用率: $used_percent"
  28. done
  29. }
  30. function tcp_status() {
  31. summary=$(ss -antp |awk '{status[$1]++}END{for(i in status) printf i":"status[i]" "}')
  32. echo "TCP连接状态 - $summary"
  33. }
  34. cpu
  35. memory
  36. disk
  37. tcp_status

找出占用 CPU 内存过高的进程脚本

  1. ps -eo user,pid,pcpu,pmem,args --sort=-pcpu |head -n 10
  2. ps -eo user,pid,pcpu,pmem,args --sort=-pmem |head -n 10

自动发布 Java 项目(Tomcat)

  1. #!/bin/bash
  2. DATE=$(date +%F_%T)
  3. TOMCAT_NAME=$1
  4. TOMCAT_DIR=/usr/local/$TOMCAT_NAME
  5. ROOT=$TOMCAT_DIR/webapps/ROOT
  6. BACKUP_DIR=/data/backup
  7. WORK_DIR=/tmp
  8. PROJECT_NAME=tomcat-java-demo
  9. # 拉取代码
  10. cd $WORK_DIR
  11. if [ ! -d $PROJECT_NAME ]; then
  12. git clone [url=https://github.com/lizhenliang/tomcat-java-demo]https://github.com/lizhenliang/tomcat-java-demo[/url]
  13. cd $PROJECT_NAME
  14. else
  15. cd $PROJECT_NAME
  16. git pull
  17. fi
  18. # 构建
  19. mvn clean package -Dmaven.test.skip=true
  20. if [ $? -ne 0 ]; then
  21. echo "maven build failure!"
  22. exit 1
  23. fi
  24. # 部署
  25. TOMCAT_PID=$(ps -ef |grep "$TOMCAT_NAME" |egrep -v "grep|$$" |awk 'NR==1{print $2}')
  26. [ -n "$TOMCAT_PID" ] && kill -9 $TOMCAT_PID
  27. [ -d $ROOT ] && mv $ROOT $BACKUP_DIR/${TOMCAT_NAME}_ROOT$DATE
  28. unzip $WORK_DIR/$PROJECT_NAME/target/*.war -d $ROOT
  29. $TOMCAT_DIR/bin/startup.sh

自动发布 PHP 项目脚本

  1. #!/bin/bash
  2. DATE=$(date +%F_%T)
  3. WWWROOT=/usr/local/nginx/html/$1
  4. BACKUP_DIR=/data/backup
  5. WORK_DIR=/tmp
  6. PROJECT_NAME=php-demo
  7. # 拉取代码
  8. cd $WORK_DIR
  9. if [ ! -d $PROJECT_NAME ]; then
  10. git clone [url=https://github.com/lizhenliang/php-demo]https://github.com/lizhenliang/php-demo[/url]
  11. cd $PROJECT_NAME
  12. else
  13. cd $PROJECT_NAME
  14. git pull
  15. fi
  16. # 部署
  17. if [ ! -d $WWWROOT ]; then
  18. mkdir -p $WWWROOT
  19. rsync -avz --exclude=.git $WORK_DIR/$PROJECT_NAME/* $WWWROOT
  20. else
  21. rsync -avz --exclude=.git $WORK_DIR/$PROJECT_NAME/* $WWWROOT
  22. fi